<?php

/**
 * FME Extensions
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the fmeextensions.com license that is
 * available through the world-wide-web at this URL:
 * https://www.fmeextensions.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    FME
 * @package     FME_CopyCategory
 * @copyright   Copyright (c) 2019 FME (http://fmeextensions.com/)
 * @license     https://fmeextensions.com/LICENSE.txt
 */

namespace FME\CopyCategory\Model\Config\Source;

use Magento\Framework\Option\ArrayInterface;
use Magento\Framework\App\RequestInterface;

class Categorylist implements ArrayInterface {

    protected $_categoryHelper;
    protected $categoryRepository;
    protected $categoryList;

    public function __construct(
    \Magento\Catalog\Helper\Category $catalogCategory, RequestInterface $request, \Magento\Catalog\Model\CategoryRepository $categoryRepository
    ) {
        $this->_categoryHelper = $catalogCategory;
        $this->request = $request;
        $this->categoryRepository = $categoryRepository;
    }
    /*
     * Option getter
     * @return array
     */

    public function toOptionArray() {


        $arr = $this->toArray();
        $ret = [];
        if (!empty($arr)):
            foreach ($arr as $key => $value) {

                $ret[] = [
                    'value' => $key,
                    'label' => $value
                ];
            }
        else:
            $ret[] = [
                'value' => '',
                'label' => 'No Sub Category'
            ];
        endif;
        return $ret;
    }

    /*
     * Get options in "key-value" format
     * @return array
     */

    public function toArray() {
        $array_cat = array();
        $categoryObj = $this->categoryRepository->get($this->request->getParam('id'));
        $this->getAllCategory($this->request->getParam('id'), $array_cat);
        return $array_cat;
    }

    public function getAllCategory($id, &$array_cat) {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $categories = $objectManager->create('Magento\Catalog\Model\Category')->load($id);
        if ($categories->hasChildren()) {
            $subcategorid = explode(',', $categories->getChildren());
            foreach ($subcategorid as $categoryId) {
                $subcategory = $objectManager->create('Magento\Catalog\Model\Category')->load($categoryId);
                $dashes = '';
                for ($i = 1; $i <= (int) $subcategory->getLevel(); $i++) {
                    $dashes .= '-';
                }
                $array_cat += [$categoryId => $dashes . ' ' . $subcategory->getName()];
                if ($subcategory->hasChildren()) {
                    $this->getAllCategory($categoryId, $array_cat);
                }
            }
        }
    }

}